using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace GridControlRowHeader
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(24, 24);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(464, 264);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 318);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridControl1.BaseStylesMap["Row Header"].StyleInfo.CellType = "Static";
			this.gridControl1.BaseStylesMap["Row Header"].StyleInfo.BackColor = SystemColors.Window;
			
			this.gridControl1.AlphaBlendSelectionColor = Color.FromArgb(0, this.gridControl1.AlphaBlendSelectionColor);
			this.gridControl1.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(gridControl1_PrepareViewStyleInfo);
			
			this.gridControl1.CurrentCellMoved += new GridCurrentCellMovedEventHandler(gridControl1_CurrentCellMoved);
			this.gridControl1.QueryNextCurrentCellPosition += new GridQueryNextCurrentCellPositionEventHandler(gridControl1_QueryNextCurrentCellPosition);

			this.gridControl1.KeyDown += new KeyEventHandler(gridControl1_KeyDown);
		}


		//color the selected rowheaders
		private void gridControl1_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
			if(e.RowIndex > 0 && e.ColIndex == 0
				&& 
				(this.gridControl1.Selections.Ranges.AnyRangeContains(GridRangeInfo.Cell(e.RowIndex, e.ColIndex))
				 || (this.gridControl1.CurrentCell.ColIndex == 0
				&& this.gridControl1.CurrentCell.RowIndex == e.RowIndex))
				)
			{
				e.Style.BackColor = Color.FromArgb(60, this.gridControl1.AlphaBlendSelectionColor);
			}
		}

		//unselect things or select a single current cell
		private void gridControl1_CurrentCellMoved(object sender, GridCurrentCellMovedEventArgs e)
		{
			bool ctl = (Control.ModifierKeys & Keys.Control) != 0;
			bool shift = (Control.ModifierKeys & Keys.Shift) != 0;
			if(!shift && !ctl)
				this.gridControl1.Selections.Clear();

			GridCurrentCell cc = this.gridControl1.CurrentCell;
			if(cc.RowIndex > 0 && cc.ColIndex == 0)
			{
				this.gridControl1.Selections.SelectRange(cc.RangeInfo, true);
				this.gridControl1.RefreshRange(cc.RangeInfo, true);
			}
		}

		//allow left arrow to move from col 1 to col 0.
		private void gridControl1_QueryNextCurrentCellPosition(object sender, GridQueryNextCurrentCellPositionEventArgs e)
		{
			if(e.ColIndex == 0)
			{
				e.Result = true;
				e.Handled = true;
				this.gridControl1.CurrentCell.MoveTo(e.RowIndex, 0);
			}
		}

		private void gridControl1_KeyDown(object sender, KeyEventArgs e)
		{
			GridCurrentCell cc = this.gridControl1.CurrentCell;
			if(cc.RowIndex > 0 && cc.ColIndex == 0 &&
				e.KeyCode == Keys.Space)
			{
				GridRangeInfo range = this.gridControl1.Selections.Ranges.ActiveRange;
				Console.WriteLine("Space on header: {0}-{1}", range.Top, range.Bottom);
			}
		}
	}
}
